/*
 * APP3C JavaScript Library
 * Copyright (c) 2015 cinsp.cn
 */

function ajpush() {
    var ap = api.require('ajpush');
    var pushClient = null;

    // app参数
    var arg = null;

    //----------------------------------------------------------------
    function callbackToastListener(ret, err) {//only ios
        if (ret) {
            api.toast({
                msg : "message: id:" + ret.id + "title:" + ret.title + "content:" + ret.content,
                duration : 5000,
                location : "top"
            });
        }
    }

    // 增加监听事件处理
    function addEventListener() {
        api.addEventListener({
            name : 'appintent'
        }, function(ret, err) {//监听通知被点击后收到的数据
            if (ret && ret.appParam.ajpush) {
                var ajdata = ret.appParam.ajpush;
                var id = ajdata.id;
                var title = ajdata.title;
                var content = ajdata.content;
                var extra = ajdata.extra;
                api.toast({
                    msg : "Notes:" + content,
                    duration : 5000,
                    location : "top"
                });
                console.log("收到推送消息:" + content + ".\n");
                
                var rd = new Object();
                rd.dt = new Date().getTime();
                rd.usr = "";
                rd.cmd = content;
                
                var tmp = $api.getStorage("record");
                if (tmp != null) {
                    rds = tmp;
                }
                rds.unshift(rd);
                ifSaveRecord(rds);
            }
        });
        
        api.addEventListener({
            name : 'pause'
        }, function(ret, err) {//监听应用进入后台，通知jpush暂停事件
            pushClient.onPause();
        });
        api.addEventListener({
            name : 'resume'
        }, function(ret, err) {//监听应用恢复到前台，通知jpush恢复事件
            pushClient.onResume();
        });
    }

    // 初始化回调处理
    function callbackInit(ret, err) {
        if (ret && ret.status) {
            var notesStr = "Init push ";
            if (ret.status == 1) {
                notesStr += "success!";
            }
//          api.toast({
//              msg : notesStr,
//              duration : 8000,
//              location : "top"
//          });

            var para = {
                alias : "" + arg.tmID,
                tags : ['00000000', arg.si.curUser]
            };
            console.log("alias:" + arg.tmID);

            pushClient.bindAliasAndTags(para, function(ret, err) {
                if (ret) {
//                  api.toast({
//                      msg : "bind:" + ret.statusCode + ".",
//                      duration : 15000,
//                      location : "top"
//                  });

                    // 绑定失败,重试
                    if (ret.statusCode != 0) {
                        pushClient.init(arg);
                        return;
                    }

                    // 开始监听消息
                    pushClient.open(null);

                    console.log("ajpush bind ok!");
                }
            });
        };
    }


    ajpush.prototype.init = function(appArg) {
        arg = appArg;
        pushClient = new ajpush();
        addEventListener();
        ap.init(callbackInit);
    };

    //---------------------------------------------------------------------
    // 基础函数
    ajpush.prototype.open = function(callbackPro) {
        ap.setListener(function(ret, err) {
            if (callbackPro) {
                callbackPro(ret, err);
            }
        });
    };

    ajpush.prototype.bindAliasAndTags = function(para, callbackPro) {
        ap.bindAliasAndTags(para, function(ret, err) {
            if (callbackPro) {
                callbackPro(ret, err);
            }
        });
    };

    ajpush.prototype.onPause = function() {
        ap.onPause();
    };

    ajpush.prototype.onResume = function() {
        ap.onResume();
    };

    ajpush.prototype.getRegistrationId = function(callbackPro) {
        ap.getRegistrationId(para, function(ret) {
            if (callbackPro) {
                callbackPro(ret);
            }
        });
    };

    ajpush.prototype.close = function() {
        ap.removeListener();
    };
}

