/*
* APP3C JavaScript Library
* Copyright (c) 2015 cinsp.cn
*/

// *：此文件只在ROOT引用一次

// 参数
var af = null;

// 资源
var rs = null;

// 整个应用的数据结构
function appArg() {
    // 不需要更新到服务器部份
    // 网络配置---------------------------------------------------
    var net = new Object();
    // 网络
    net.serverIP = "211.149.246.181";
    net.serverPort = 8889; // 9923
    net.serverIPBak = "211.149.246.181";
    net.serverPortBak = 8889; // 9923
    net.dns = "www.cinsp.cn";
    net.imgPath = "../image/head.jpg";

    // 需要更新到服务器部份
    // 基本配置---------------------------------------------------
    var bc = new Object();
    // 机器号
    //bc.uuid = 123456;
    // 是否激活
    bc.active = 0;

    // 心跳时间
    bc.beat = 300;

    // 响铃时间
    bc.ringTimes = 60;
    // 报警电话(<5)
    var tels = new Array();
    tels[0] = "";
    bc.telNum = 0;
    bc.tels = tels;
    // 短信电话
    var smsTels = new Array();
    smsTels[0] = "";
    bc.smsTelNum = 0;
    bc.smsTels = smsTels;
    // 断电/来电 号码
    bc.smsPwrTel = "";
    // 低压报警
    bc.smsLvTel = "";
    // alarm/disalarm SMS 布防 撤防
    bc.smsArmTel = "";

    // 接入点
    var gprs = new Object();
    gprs.apn = "cmnet";
    gprs.usr = "cmnet";
    gprs.pwd = "cmnet";
    // 短信中心号码
    gprs.mcn = "";
    
    // 布防配置---------------------------------------------------
    var dc = new Object();
    // 自动布防
    // dc.autoDefence = 0;
    // 遥控键,每5个一组,分别为:0:外出布防按键;1,撤防按键;2,在家布防按键;3,外出布防按键;4,紧急求救按键
    // var remoteKeys = new Array();
    // remoteKeys[0] = 0;
    // dc.remoteKeys = remoteKeys;

    // 是否发短信
    dc.sms = 1;
    // 是否打电话
    dc.tel = 1;
    // 是否使用网络(wifi,gprs)
    dc.msg = 1;
    // 喇叭开关
    dc.spk = 1;
    // 是否对外供电
    dc.op = 1;
    // 低电是否报警
    dc.lpwr = 1;
    // 断电/来电是否报警
    dc.pd = 1;
    // 是否允许对外供电
    dc.op = 1;

    // 组设置,共2*7个-----------------------------------
    var dg = new Object();
    dg.autoOn = 0;
    //dg.autoOff = 0;
    dg.week = 1; //4 x 7
    dg.armDt = 0x0830;
    dg.disDt = 0x1830;
    var dgs = new Array();
    dgs.push(dg);

    // fo:主机专用,不可配置
    var fo = new Object();
    // 传感器序号
    fo.no = 0;
    fo.sn = 0;
    fo.on = 0;
    // 防区类型:0在家,1外出,2门铃,3紧急,0x4撤防
    fo.zt = 0;
    fo.name = "A1";
    // 布防延时
    fo.dd = 0;
    // 报警延时
    fo.ad = 0;
    // 报警时间 :分钟
    fo.at = 1;
    var fos = new Array();
    fos.push(fo);

    // 状态信息-----------------------------------
    var si = new Object();

    // 当前APP用户信息
    si.curUser = "jhf";
    si.curPwd = "1234";
    // 记住密码
    si.rb = 0;
    // 登录状态
    si.li = false;
    // 布防类型
    si.dt = 0;
    // 电池电量
    si.batv = 4000;

    // 远程控制-----------------------------------------
    // 控制名称
    var cn = new Array();
    var cc = new Array();
    for (var i = 0; i < 20; i++) {
        cn = "";
        cc[i] = false;
    }
    var ctr = new Object();
    ctr.name = "";
    ctr.onOff = cc;

    // 对外对像-----------------------------------------
    var obj = new Object();

    // 设备ID单独提取出来
    obj.tmID = 3;
    // 确定是APP还是主机
    obj.ct = 1;
    // 语言
    obj.lang = 1;
    // 网参数
    obj.net = net;
    // 基本配置
    obj.bc = bc;
    // 布防配置
    obj.dc = dc;
    // gprs infor
    obj.gprs = gprs;
    // 组配置
    obj.dgs = dgs;
    obj.dg = dg;
    // 快捷操作配置
    obj.fos = fos;
    // 状态信息
    obj.si = si;
    // 远程控制
    obj.ctr = ctr;

    return obj;
}

// 对外开放接口
// 设置参数
function appSaveStrArg(strPara) {
    af.saveArg(JSON.parse(strPara));
}

// 上传参数到服务器
function appUpdateStrArgToServer(strPara) {
    //console.log(strPara);
    af.updateToServer(JSON.parse(strPara));
}

function appAf() {
    var vmArg = null;
    var skt = null;
    var push = null;

    this.appArg = vmArg;

    // 存入本地参数对象
    appAf.prototype.saveArg = function(para) {
        vmArg = para;
        vmArg.timeStamp = new Date().getTime() / 1000;
        this.appArg = vmArg;

        $api.setStorage("appArg", vmArg);
    }
    // 返回本地参数对像
    appAf.prototype.getArg = function() {
        vmArg = $api.getStorage("appArg");
        if (vmArg == null) {
            return null;
        }

        return vmArg;
    }
    // 上传配置到服务器
    appAf.prototype.updateToServer = function(vmArg) {
        skt.send(JSON.stringify(vmArg));
    }
    // 连接初始化
    appAf.prototype.connectInit = function() {
        // 初始化连接
        if (skt == null) {
            skt = new socket();
        }
        
        var ipPort = {};
        ipPort.ip = vmArg.net.serverIP;
        ipPort.port = vmArg.net.serverPort;
        skt.init(ipPort);
    }
    
    // 推送初始化
    appAf.prototype.pushInit = function() {
        // 初始化消息推送
        if (push == null) {
            push = new ajpush();
        }
        push.init(vmArg);
    }
    // 初始化
    if ( typeof appAf._initialized == "undefined") {
        appAf._initialized = true;

        appAf.prototype.init = function() {
            // 初始化参数
            vmArg = this.getArg();
            if (vmArg == null) {
                console.log("无参数,使用初始值!");
                vmArg = appArg();
                $api.setStorage("appArg", vmArg);
                console.log(JSON.stringify(vmArg));
            }

            this.appArg = vmArg;
            return vmArg;
        }
    }
}

