/*
* APP3C JavaScript Library
* Copyright (c) 2015 cinsp.cn
*/

// 执行name下脚本
function ifRunScript(name, script, obj) {
    api.execScript({
        name : name,
        script : script + "('" + JSON.stringify(obj) + "')"
    });
}

// 参数相关操作

// 保存参数在本地
// 因为ROOT不会随时更新,所以要在ROOT保存数据,以便ROOT更新
function ifSaveArg(obj) {
    return ifRunScript("root", "appSaveStrArg", obj);
}

// 读取本地参数
function ifReadArg() {
    return $api.getStorage("appArg");
}

function ifSaveArgName(name, obj) {
    return $api.setStorage(name, obj);
}

function ifReadArgName(name) {
    return $api.getStorage(name);
}

// 记录相关操作
// 记录
function ifRecord() {
    var rd = new Object();
    rd.dt = new Date().getTime();
    rd.usr = "";
    rd.cmd = "";

    return rd;
}

// 保存操作记录
function ifSaveRecord(obj) {
    $api.setStorage("record", obj);
}

function ifReadRecord() {
    return $api.getStorage("record");
}

// camera相关操作
// camera
function ifCamera() {
    var ca = new Object();
    ca.name = "";
    ca.pkg = "";

    return ca;
}

// 保存操作记录
function ifSaveCamera(obj) {
    $api.setStorage("camera", obj);
}

function ifReadCamera() {
    return $api.getStorage("camera");
}

// 通信相关操作
// 上传参数到服务器
// arg:设置的参数
// callbackPro:执行完的回调函数
function ifSubmitToServer(obj, timeOut, proAcceptData, proTimeOut) {
    var timeOutState = true;

    // 监听socket接收数据
    api.addEventListener({
        name : "socketInfo"
    }, proSocketRxData);

    api.execScript({
        name : "root",
        script : "appUpdateStrArgToServer('" + JSON.stringify(obj) + "')"
    });

    // 接收数据处理
    function proSocketRxData(ret) {
        if (ret && ret.value && ret.value.state && ret.value.data) {
            api.removeEventListener({
                name : "socketInfo"
            });

            //console.log(ret.value.data);
            if (ret.value.state == 103) {
                timeOutState = false;

                if (proAcceptData) {
                    proAcceptData(ret);
                }
            }
        }
    }

    function handleTimeOut() {
        if (timeOutState == true) {
            api.removeEventListener({
                name : "socketInfo"
            });

            api.toast({
                msg : rs.txtNoAck,
                duration : 5000,
                location : "top"
            });

            if (proTimeOut) {
                proTimeOut();
            }
        }
    }

    // 处理超时
    setTimeout(handleTimeOut, timeOut);
}

// 处理参数变更
function updateArgWithAcceptData(curArg, ret) {
    console.log("rx:" + ret.value.data);

    if (ret && ret.value && ret.value.state && ret.value.data) {
        var arg = JSON.parse(ret.value.data);
        if (arg.tmID == curArg.tmID) {
            if (arg.ct == 0x42) {
                var bc = new Object();
                bc = $.extend({}, bc, arg.bc1);
                bc = $.extend({}, bc, arg.bc2);
                bc = $.extend({}, bc, arg.bc3);
                bc = $.extend({}, bc, arg.bc4);

                curArg.bc = bc;
                curArg.dc = arg.dc;
                curArg.dgs = arg.dgs;
                //curArg.gprs = arg.gprs;

                curArg.fos = arg.fos;
                if (arg.si != null) {
                    curArg.si.dt = arg.si.dt;
                }

                ifSaveArg(curArg);

                console.log("curArg:" + JSON.stringify(curArg));

                return curArg;
            } else if (arg.ct == 0x30) {
                if (arg.si != null) {
                    curArg.si.batv = arg.si.batv;
                    curArg.si.dt = arg.si.dt;
                }

                return curArg;
            }
        }
    }

    return curArg;
}

// 窗口操作相关
// 打开页面
function ifOpenFrame(name, destUrl, para) {
    api.openFrame({
        name : name,
        url : destUrl,
        pageParam : {
            //arg : para
        },
        bounces : false,
        vScrollBarEnabled : true,
        hScrollBarEnabled : false,
        reload : true,
        delay : 100
    });
}

// 打开窗口
function ifOpenWin(name, destUrl, para) {
    api.openWin({
        name : name,
        url : destUrl,
        pageParam : {
            //arg : para
        },
        animation : {
            type : "movein",
            subType : "from_left",
            duration : 400
        },
        bounces : false,
        vScrollBarEnabled : false,
        hScrollBarEnabled : false,
        reload : true,
        delay : 100
    });
}

// 关闭窗口
function ifCloseToWin(name) {
    api.closeToWin({
        name : name,
        animation : {
            type : "push",
            subType : "from_right",
            duration : 300
        }
    });
}