/*
* APP3C JavaScript Library
* Copyright (c) 2015 cinsp.cn
*/

//---------------------------------------------------------------------
// 连接状态
function socket() {
    var socketManager = api.require('socketManager');

    // 连接客户端
    var socketClient = null;

    var segData = "";

    // sokcet需要的参数
    var arg = {};

    // socket状态
    var sid = 0;
    
    var errCnt = 0;

    // 发送结果处理回调试函数
    function callbackSocketSend(ret, err) {
        if (ret.status == true) {
            api.sendEvent({
                name : "socketInfo",
                extra : {
                    state : ret.status,
                    msg : "socketSendDataOk",
                    data : ""
                }
            });
            //console.log("数据发送成功.");
        } else {
            api.sendEvent({
                name : "socketInfo",
                extra : {
                    state : ret.status,
                    msg : "socketSendDataError",
                    data : ""
                }
            });
            api.sendEvent({
                name : "socketSendDataError",
                extra : {
                    state : ret.status,
                    msg : "",
                    data : ""
                }
            });
            console.log("数据发送失败.");
        }
    };

    function callBackSocketClose(ret, err) {
        if (ret.status) {
            console.log("关闭成功!");
        } else {
            console.log("关闭失败!");
        }

        //setTimeout(reconnect, 5000);
    }

    // 连接及接收数据处理回调试函数
    function callbackSocketOpen(ret, err) {// 创建成功
        if (ret.state == 101) {// 创建成功
        } else if (ret.state == 102) {// 连接成功
            api.sendEvent({
                name : "socketInfo",
                extra : {
                    state : ret.state,
                    msg : "socketConnectedOk",
                    data : ""
                }
            });
            
            api.sendEvent({
                name : "socketConnectedOk",
                extra : {
                    state : ret.state,
                    msg : "",
                    data : ""
                }
            });

            console.log("网络连接成功!");
        } else if (ret.state == 103) {// 收到数据
            try {
                var jsonObj = JSON.parse(ret.data);

                api.sendEvent({
                    name : 'socketInfo',
                    extra : {
                        state : ret.state,
                        msg : "socketAcceptData",
                        data : ret.data
                    }
                });
                api.sendEvent({
                    name : 'ifSocketAcceptData',
                    extra : {
                        state : ret.state,
                        data : ret.data
                    }
                });
            } catch(e) {
                console.log("分段.\n");

                segData += ret.data;
                // 检查拼接后数据是否完整
                try {
                    var jsonObj = JSON.parse(segData);
                    api.sendEvent({
                        name : 'socketInfo',
                        extra : {
                            state : ret.state,
                            msg : "socketAcceptData",
                            data : segData
                        }
                    });
                    api.sendEvent({
                        name : 'ifSocketAcceptData',
                        extra : {
                            state : ret.state,
                            data : segData
                        }
                    });
                    // console.log("收到数据:" + segData);
                    segData = "";
                } catch(e) {
                    if (segData.length > 1024 * 16) {
                        segData = "";
                    }
                    return;
                }
            }
        } else if (ret.state == 204) {
        } else {
            console.log("其它问题.");
            if(errCnt++ > 1){
                errCnt = 0;
                socketClient.close(callBackSocketClose);
            }
        }

    };

    // 重连接
    function reconnect() {
        if (arg) {
            socketClient.close();
            socketClient.open(arg.ip, arg.port, "tcp", "GBK", callbackSocketOpen);
            console.log("重连接.");
        }
    }

    // 初始化
    if ( typeof socket._initialized == "undefined") {
        socket._initialized = true;

        // 重连接
        socket.prototype.reconnect = function() {
            reconnect();
        }
        // 初始化连接
        socket.prototype.init = function(ipPort, callbackOpenPro) {
            arg = ipPort;
            if (socketClient != null) {
                console.log("socketClient.close().");
                socketClient.close();
            }
            
            socketClient = new socket();
            if (callbackOpenPro) {
                console.log("socketClient.open().0: ip:" + arg.ip + ", port:" + arg.port);
                socketClient.open(arg.ip, arg.port, "tcp", "GBK", callbackOpenPro);
            } else {
                console.log("socketClient.open().1: ip:" + arg.ip + ", port:" + arg.port);
                socketClient.open(arg.ip, arg.port, "tcp", "GBK", callbackSocketOpen);

                // 监听获取通信状态请求
                addEventListener("socketGetInfo", function(ret) {
                    if (ret && ret.value) {
                        api.sendEvent({
                            name : 'socketInfo',
                            extra : {
                                state : ret.value.state,
                                msg : "socketAckGetInfo",
                                data : ret.value.data
                            }
                        });
                    }
                });
            }
        }
        //---------------------------------------------------------------------
        // 基础函数
        /*
         *101 = "创建成功"
         *102 = "连接成功"
         *103 = "收到消息"
         *201 = "创建失败"
         *202 = "连接失败"
         *203 = "异常断开"
         *204 = "正常断开"
         *205 = "发生未知错误"
         */
        socket.prototype.open = function(destIP, destPort, conType, charSet, callbackPro) {
            socketManager.createSocket({
                type : conType,
                host : destIP,
                port : destPort,
                charset : charSet,
                timeout : 5,
                bufferSize : 32
            }, function(ret, err) {
                if (ret) {
                    sid = ret.sid;
                    if (socketManager) {
                        callbackPro(ret, err);
                    }
                }
            });
        };

        /*
         * data:需要发送的数据,字符串
         * callbackPro:发送结构回调波函数
         */
        socket.prototype.send = function(data, callbackProSend) {
            if (socketManager) {
                console.log("Tx:" + data);
                socketManager.write({
                    sid : sid, // 由createSocket方法获取得到
                    data : data
                }, function(ret, err) {
                    if (callbackProSend) {
                        callbackProSend(ret, err);
                    } else {
                        callbackSocketSend(ret, err);
                    }
                });
            }
        };

        /*
         * 关闭连接
         */
        socket.prototype.close = function(callbackProClose) {
            if (socketManager) {
                socketManager.closeSocket({
                    sid : sid
                }, function(ret, err) {
                    if (callbackProClose) {
                        callbackProClose(ret, err);
                    } else {
                        callBackSocketClose(ret, err);
                    }
                });
            }
        };
    }
}

