/*
* APP3C JavaScript Library
* Copyright (c) 2015 cinsp.cn
*/

// name
// div
function miniTable(name, el) {
    // 表格体单元格
    var tbodyTd = new Object;
    tbodyTd.classes = new Array;
    tbodyTd.content = null;
    var tbodyTds = new Array;
    //tbodyTds[0] = tbodyTd;
    // 表格体行
    var tbodyTr = new Object;
    tbodyTr.classes = new Array;
    tbodyTr.tbodyTds = tbodyTds;
    var tbodyTrs = new Array;
    //tbodyTrs[0] = tbodyTr;
    // 表格体
    var tbody = new Object;
    tbody.classes = new Array;
    tbody.tbodyTrs = tbodyTrs;

    // 表头单元格
    var theadTh = new Object;
    theadTh.classes = new Array;
    theadTh.content = null;
    var theadThs = new Array;
    theadThs[0] = theadTh;
    // 表头行
    var theadTr = new Object;
    theadTr.classes = new Array;
    theadTr.theadThs = theadThs;
    // 表头
    var thead = new Object;
    thead.classes = new Array;
    thead.theadTr = theadTr;

    // 标题
    var caption = new Object;
    caption.classes = new Array;
    caption.content = null;

    var table = new Object;
    table.id = name + "ID";
    table.el = el;
    table.classes = "table table-hover table-bordered";
    table.caption = caption;
    table.thead = thead;
    table.tbody = tbody;

    table.init = function() {
        // table
        var str = "";
        str += "<table";
        if (table.classes) {
            str += " class=\"";
            str += table.classes;
            str += "\"";
        }
        str += ">\n";

        // caption
        if (table.caption) {
            var tc = table.caption;

            str += "<caption";
            if (tc.classes && tc.classes.length > 0) {
                str += " class=\"";
                var cs = tc.classes;
                for (var i = 0; i < cs.length; i++) {
                    str += cs[i] + "";
                }
                str += "\"";
            }
            str += ">\n";

            if (tc.content) {
                var c = tc.content;
                str += c;
            }
            str += "<\/caption>\n";
        }

        // head
        if (table.thead) {
            var th = table.thead;
            str += "<thead";
            if (th.classes && th.classes.length > 0) {
                str += " class=\"";
                var cs = th.classes;
                for (var i = 0; i < cs.length; i++) {
                    str += cs[i] + "";
                }
                str += "\"";
            }
            str += ">\n";
            if (th.theadTr) {
                var tr = th.theadTr;
                str += "<tr";
                if (tr.classes && tr.classes.length > 0) {
                    str += " class=\"";
                    var cs = tr.classes;
                    for (var i = 0; i < cs.length; i++) {
                        str += cs[i] + "";
                    }
                    str += "\"";
                }
                str += ">\n";
                if (tr.theadThs) {
                    var ths = tr.theadThs;
                    for (var i = 0; i < ths.length; i++) {
                        var th = ths[i];
                        if (th) {
                            str += "<th "
                            if (th.classes && th.classes.length > 0) {
                                str += " class=\"";
                                var cs = th.classes;
                                for (var n = 0; n < cs.length; n++) {
                                    str += cs[n] + "";
                                }
                                str += "\"";
                            }
                            str += ">\n";
                            if (th.content) {
                                var c = th.content;
                                str += c;
                            }
                            str += "<\/th>\n";
                        }
                    }
                }
                str += "<\/tr>\n";
            }
            str += "<\/thead>\n";
        }

        // body
        if (table.tbody) {
            var tb = table.tbody;
            str += "<tbody";
            if (tb.classes && tb.classes.length > 0) {
                str += " class=\"";
                var cs = tb.classes;
                for (var i = 0; i < cs.length; i++) {
                    str += cs[i] + "";
                }
                str += "\"";
            }
            str += ">\n";
            if (tb.tbodyTrs) {
                var trs = tb.tbodyTrs;
                for (var k = 0; k < trs.length; k++) {
                    var tr = trs[k];
                    str += "<tr";
                    if (tr.classes && tr.classes.length > 0) {
                        str += " class=\"";
                        var cs = tr.classes;
                        for (var i = 0; i < cs.length; i++) {
                            var cs = tr.classes;
                            str += cs[k] + "";
                        }
                        str += "\"";
                    }
                    str += ">\n";
                    if (tr.tbodyTds) {
                        var ths = tr.tbodyTds;
                        for (var i = 0; i < ths.length; i++) {
                            var th = ths[i];
                            if (th) {
                                str += "<th "
                                if (th.classes && th.classes.length > 0) {
                                    str += " class=\"";
                                    var cs = th.classes;
                                    for (var n = 0; n < cs.length; n++) {
                                        str += cs[n] + "";
                                    }
                                    str += "\"";
                                }
                                str += ">\n";
                                if (th.content) {
                                    var c = th.content;
                                    str += c;
                                }
                                str += "<\/th>\n";
                            }
                        }
                    }
                    str += "<\/tr>\n";
                }
                str += "<\/tbody>\n";
            }
            str += "<\/table>\n";
        }

        return str;
    }
    // 增加表头
    table.addHead = function(tr, tb) {
        var theadTr = new Object;
        theadTr.theadThs = new Array;

        for (var i = 0; i < tr.length; i++) {
            var td = new Object;
            td.content = tr[i];
            theadTr.theadThs.push(td);
        }

        tb.thead.theadTr = theadTr;
    }
    // 增加行
    table.add = function(tr, tb) {
        var tbodyTr = new Object;
        tbodyTr.tbodyTds = new Array;

        for (var i = 0; i < tr.length; i++) {
            var td = new Object;
            td.content = tr[i];
            tbodyTr.tbodyTds.push(td);
        }

        tb.tbody.tbodyTrs.push(tbodyTr);
    }
    // 删除行
    var del = function(index) {
    }

    return table;
}
